; JPM;#RequireAdmin
;
; AutoIt Version: 3.0
; Language:       English
; Platform:       Win9x/NT
; Author: Jos van der Zande
; Email : jdeb@autoitscript.com
;
; Script Function:
; Store this script in the Helpfile directory where the project file is stored.
; It assumes that the Include directory is a subdir of directory defined in the registry key: "HKEY_LOCAL_MACHINE\SOFTWARE\AutoIt v3\AutoIt","Installdir"
; It will read all *.au3 files in this include directory and create the \html\libfunctions.htm.
; It wil also create one description file per ???.au3 it finds. this will be stored in \html\libfunctions\????.htm.
; All descriptions which are specified in the ???.AU3 are copied into this description htm file and
; references are created to these in the \html\libfunctions.htm.
; ******************************************************
; Read all Include functions and generate helpfile
; ******************************************************
; remove old file that contains a list of userfunctions
; Generate the index File

#include <FileConstants.au3>
#include <MsgBoxConstants.au3>

#include "..\..\_build\include\MiscLib.au3"
#include "..\..\_build\include\OutputLib.au3"

Opt("TrayIconDebug", 1)

OnAutoItExitRegister("OnQuit") ; ### When run in standalone
_OutputWindowCreate() ; ### When run in standalone

FileChangeDir(@ScriptDir)

; to be used for passing the /RegenAll
Local $sCmd1 = ""
If $CmdLine[0] Then $sCmd1 = $CmdLine[1]

_OutputBuildWrite("Generate HTM files for all changed Functions/Keywords" & @CRLF)
RunWait('"' & @AutoItExe & '"' & ' ..\..\_build\include\Gen_txt2Htm.au3 /AutoIt ' & $sCmd1)

_OutputBuildWrite("Generate Reference HTM files for Functions/Keywords" & @CRLF)
RunWait('"' & @AutoItExe & '"' & ' ..\..\_build\include\Gen_RefPages.au3 /AutoIt')

_OutputBuildWrite("Creating the index entries for all builtin functions/keywords" & @CRLF)
Main()

_OutputBuildWrite("Generate Management HTM files for Functions" & @CRLF)
RunWait('"' & @AutoItExe & '"' & ' ..\..\_build\include\Gen_MgtPages.au3 /AutoIt')

_OutputBuildWrite("Generate ExitCodes HTM file" & @CRLF)
RunWait('"' & @AutoItExe & '"' & ' Gen_ExitCodesPage.au3')

_OutputBuildWrite("Generate OSLangCodes HTM file" & @CRLF)
RunWait('"' & @AutoItExe & '"' & ' Gen_OSLangCodesPage.au3')

_OutputBuildWrite("Converting autoit_changelog.txt to history.htm file" & @CRLF)
RunWait('"' & @AutoItExe & '"' & ' Gen_ChangeLog.au3')

Func OnQuit()
	_OutputWaitClosed() ; ### When run in standalone
EndFunc   ;==>OnQuit

Func Main()
	Local $hFI_TOC_HND = FileOpen("AutoIt3 TOC.hhc")
	Local $sFO_INDEX_HND = FileOpen("AutoIt3 Index.hhk", BitOR($FO_OVERWRITE_CREATE, $FO_UTF8))
	; Check if file opened for reading OK
	If $hFI_TOC_HND = -1 Then
		MsgBox($MB_SYSTEMMODAL, "Error", "Unable to open file.")
		Exit
	EndIf
	; start
	FileWriteLine($sFO_INDEX_HND, '<!DOCTYPE HTML PUBLIC "-//IETF//DTD HTML//EN">')
	FileWriteLine($sFO_INDEX_HND, '<HTML>')
	FileWriteLine($sFO_INDEX_HND, '<HEAD>')
	FileWriteLine($sFO_INDEX_HND, '<meta name="GENERATOR" content="Microsoft&reg; HTML Help Workshop 4.1">')
	FileWriteLine($sFO_INDEX_HND, '<!-- Sitemap 1.0 -->')
	FileWriteLine($sFO_INDEX_HND, '</HEAD><BODY>')
	FileWriteLine($sFO_INDEX_HND, '<UL>')
	; jump to last record processed
	Local $sLINE, $iMACROSECTION, $sTNAME, $sFN, $hFI_TOC_HNDI, $sLINEI
	Local $sNAME = ""
	While 1
		$sLINE = FileReadLine($hFI_TOC_HND)
		If @error = -1 Then
			ExitLoop
		EndIf
		Select
			Case StringInStr(StringLower($sLINE), '<li>') > 0
				$sNAME = ""
			Case StringInStr(StringLower($sLINE), '<param name="name"') > 0
				$sNAME = StringReplace($sLINE, Chr(09), "")
				If StringInStr($sLINE, ' Macros"') > 0 Then
					$iMACROSECTION = 1
				Else
					$iMACROSECTION = 0
				EndIf
			Case StringInStr(StringLower($sLINE), '<param name="local"') > 0
				FileWriteLine($sFO_INDEX_HND, '<LI> <OBJECT type="text/sitemap">')
				FileWriteLine($sFO_INDEX_HND, '   ' & $sNAME)
				FileWriteLine($sFO_INDEX_HND, '   ' & StringReplace($sLINE, Chr(09), ""))
				FileWriteLine($sFO_INDEX_HND, '		</OBJECT>')
				; create entries in index for #include as include
				If StringInStr($sNAME, 'value="#') > 0 And StringInStr($sNAME, '...') = 0 Then
					FileWriteLine($sFO_INDEX_HND, '<LI> <OBJECT type="text/sitemap">')
					FileWriteLine($sFO_INDEX_HND, '   ' & StringReplace($sNAME, "#", ""))
					FileWriteLine($sFO_INDEX_HND, '   ' & StringReplace($sLINE, Chr(09), ""))
					FileWriteLine($sFO_INDEX_HND, '		</OBJECT>')
				EndIf
				; gen entry in index for each FuncName on a line like Func XXX()
				If StringInStr($sNAME, "()") > 0 Then
					$sTNAME = StringStripWS(StringReplace(StringLeft($sNAME, StringInStr($sNAME, "()") - 1), "Func ", ""), 2) & '">'
					FileWriteLine($sFO_INDEX_HND, '	<LI> <OBJECT type="text/sitemap">')
					FileWriteLine($sFO_INDEX_HND, '   ' & $sTNAME)
					FileWriteLine($sFO_INDEX_HND, '   ' & StringReplace($sLINE, Chr(09), ""))
					FileWriteLine($sFO_INDEX_HND, '		</OBJECT>')
				EndIf
				; gen entry in index for each keyword on a line like If...Else...EndIf
				If StringInStr($sNAME, "...") > 0 Then
					While StringInStr($sNAME, "...") > 0
						$sTNAME = StringLeft($sNAME, StringInStr($sNAME, "...") - 1) & '">'
						$sNAME = StringLeft($sNAME, StringInStr($sNAME, 'value="') + 6) & StringTrimLeft($sNAME, StringInStr($sNAME, "...") + 2)
						FileWriteLine($sFO_INDEX_HND, '	<LI> <OBJECT type="text/sitemap">')
						FileWriteLine($sFO_INDEX_HND, '   ' & $sTNAME)
						FileWriteLine($sFO_INDEX_HND, '   ' & StringReplace($sLINE, Chr(09), ""))
						FileWriteLine($sFO_INDEX_HND, '		</OBJECT>')
						; create entries in index for #include as include
						If StringInStr($sTNAME, 'value="#') > 0 Then
							FileWriteLine($sFO_INDEX_HND, '<LI> <OBJECT type="text/sitemap">')
							FileWriteLine($sFO_INDEX_HND, '   ' & StringReplace($sTNAME, "#", ""))
							FileWriteLine($sFO_INDEX_HND, '   ' & StringReplace($sLINE, Chr(09), ""))
							FileWriteLine($sFO_INDEX_HND, '		</OBJECT>')
						EndIf
					WEnd
					FileWriteLine($sFO_INDEX_HND, '	<LI> <OBJECT type="text/sitemap">')
					FileWriteLine($sFO_INDEX_HND, '   ' & $sNAME)
					FileWriteLine($sFO_INDEX_HND, '   ' & StringReplace($sLINE, Chr(09), ""))
					FileWriteLine($sFO_INDEX_HND, '		</OBJECT>')
					; create entries in index for #include as include
					If StringInStr($sNAME, 'value="#') > 0 Then
						FileWriteLine($sFO_INDEX_HND, '<LI> <OBJECT type="text/sitemap">')
						FileWriteLine($sFO_INDEX_HND, '   ' & StringReplace($sNAME, "#", ""))
						FileWriteLine($sFO_INDEX_HND, '   ' & StringReplace($sLINE, Chr(09), ""))
						FileWriteLine($sFO_INDEX_HND, '		</OBJECT>')
					EndIf
				EndIf
				; Add StringRegExpGUI
				If StringInStr($sLINE, "tutorials\regexp\") Then
					FileWriteLine($sFO_INDEX_HND, '<LI> <OBJECT type="text/sitemap">')
					FileWriteLine($sFO_INDEX_HND, '   <param name="Name" value="StringRegExpGUI">')
					FileWriteLine($sFO_INDEX_HND, '   ' & StringReplace($sLINE, Chr(09), ""))
					FileWriteLine($sFO_INDEX_HND, '		</OBJECT>')
				EndIf
				; Skip link to sub-sections for the Project file
				If StringInStr($sLINE, "#") = 0 Then
					$sFN = StringTrimRight(StringTrimLeft($sLINE, StringInStr(StringLower($sLINE), 'value="') + 6), 2)
					; Read the HTM file for all @ MAcros and generate index entry for them
					If $iMACROSECTION = 1 Then
						; open the HTM file for Input
						$hFI_TOC_HNDI = FileOpen($sFN)
						If $hFI_TOC_HNDI = -1 Then
							MsgBox(0, "Error", "Unable to open: " & $sFN)
						EndIf
						While 1
							$sLINEI = FileReadLine($hFI_TOC_HNDI)
							If @error = -1 Then
								ExitLoop
							EndIf
							; Check for '>@' or '> @'
							Local $aName = StringRegExp($sLINEI, "<td>.*?>(@\w+)<.*?</td>", 1)
							If UBound($aName) Then
								$sNAME = $aName[0]
								; MsgBox(0,$sNAME,$sNAME)
								FileWriteLine($sFO_INDEX_HND, '	<LI> <OBJECT type="text/sitemap">')
								FileWriteLine($sFO_INDEX_HND, '   <param name="Name" value="' & $sNAME & '">')
								FileWriteLine($sFO_INDEX_HND, '   <param name="Local" value="' & $sFN & '#' & $sNAME & '">')
								FileWriteLine($sFO_INDEX_HND, '		</OBJECT>')
							EndIf
						WEnd
						FileClose($hFI_TOC_HNDI)
					EndIf
				EndIf
		EndSelect
	WEnd
	;end
	FileWriteLine($sFO_INDEX_HND, '</UL>')
	FileWriteLine($sFO_INDEX_HND, '</BODY></HTML>')
	;
	FileClose($hFI_TOC_HND)
	FileClose($sFO_INDEX_HND)
EndFunc   ;==>Main
